/**
 * @(#)CivLog.java
 * Spec of CivLog File: With an extension name .log
 *                      Start at 1st byte with the string "#FREECIV SCORELOG" 17 chars
 *                      No extra \n\r between line
 *                      int used for year and values data
 *
 *
 * Created on July 23, 2000, 4:26 PM
 */


/**
 *
 * @author  furyhawk <lookmeow@magix.com.sg>
 * @version 0.6.0
 */

/**
   ********************************************************************
 CivLog - Copyleft (C) 2000 - Wong Teck Meng
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
**********************************************************************/

package org.freeciv.civlog;

import org.freeciv.civlog.gui.MainFrame;
import org.freeciv.civlog.gui.SwingUtil;

import javax.swing.*;

import java.awt.*;
import java.io.File;

public class CivLog extends Object
{

    /////////////////////////////////////////////////////////////
    // CONSTANTS
    /////////////////////////////////////////////////////////////

    /** Current CivLog's release. */
    public static final String RELEASE = "0.6";

    /** Last CivLog's build date. */
    public static final String BUILD = "00.09.15";

    /** Program name */
    public static final String PROGRAMNAME = "CivLog ";

    /** Email comments and patches to */
    public static final String EMAIL = "civlog-list@lists.sourceforge.net";

    /** Help Text file name */
    public static final String HELP_TEXT_FILE = "Readme";

    /** About Text file name */
    public static final String ABOUT_TEXT_FILE = "ABOUT";

    /**
     * @param args the command line arguments
     */
    public static void main (String args[])
    {
        // DEBUG: pipe std.error to std.out
        System.setErr(System.out);

        System.out.println ( PROGRAMNAME + RELEASE + " initializing...");
        Debug.trace ("Java version:"+System.getProperty ("java.version"));
        Debug.trace ("OS Name:"+System.getProperty ("os.name"));
        Debug.trace ("OS version:"+System.getProperty ("os.version"));
        Debug.trace ("OS arch:"+System.getProperty ("os.arch"));

        MainFrame mainFrame = new MainFrame();

        /** get window size from Properties */
        String windowWidth = CLProperties.getProperty("windowWidth");
        String windowHeight = CLProperties.getProperty("windowHeight");
        if ( (windowWidth != null) && (windowHeight != null))
        {
            try
            {
                mainFrame.setSize (Integer.parseInt (windowWidth),
                                   Integer.parseInt (windowHeight));
            }
            catch (NumberFormatException nfe)
            {
                throw new RuntimeException ("Error: while parsing window sizes");
            }
        }
        else
        {
            /** Set default screen size */
            Dimension screenSize = Toolkit.getDefaultToolkit ().getScreenSize ();
            mainFrame.setSize (screenSize.width*11/12,screenSize.height*11/12);
        }

        mainFrame.setTitle (PROGRAMNAME + RELEASE);
        Debug.trace( "main: Attempting to load main frame" );
        //mainFrame.pack();
        SwingUtil.centerWindow( mainFrame );
        mainFrame.show ();

        if (args.length > 0)
        {
            try
            {
                Thread.sleep(2*1000);
            }
            catch(InterruptedException e)
            {
                e.printStackTrace();
            }

            File file = new File (args[0]);
            mainFrame.openFile (file);
        }

        Debug.trace("main: CivLog main thread exiting.");
    }
}
// End of CivLog.java
