/**
 * @(#)MainFrame.java
 *
 * Created on July 23, 2000, 4:28 PM
 */


/**
 *
 * @author  furyhawk <lookmeow@magix.com.sg>
 * @author  Raimar Falke <rf13@inf.tu-dresden.de>
 * @author  Michael Grundel <michael42@grundel.de>
 * @version 0.16
 *
 * TODO: Universal Version String config.h.in?
 */

/**
 ********************************************************************
CivLog - Copyleft (C) 2000 - Wong Teck Meng
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 **********************************************************************
 */
package org.freeciv.civlog.gui;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

import org.freeciv.civlog.Debug;
import org.freeciv.civlog.CLProperties;
import org.freeciv.civlog.FreecivConstants;
import org.freeciv.civlog.CivLog;
import org.freeciv.civlog.ColorManager;
import org.freeciv.civlog.data.Score;

public class MainFrame extends javax.swing.JFrame

{
    private GraphList graphList;
    private String lastFile;
    public Score score;
    public View view;

    private JCheckBox[] jcbDataList; // holds all Data JCheckBoxes
    private RangeMonitor rangeMonitor;

    /** Creates new form MainFrame */
    public MainFrame ()
    {
        Debug.trace ( "MainFrame.MainFrame(): initializing" );
        initComponents ();
        /** Forte use initComponents (), we use myInitComponents () */
        /** initialized your variables here */
        myInitComponents ();
        pack ();
        Debug.trace ( "MainFrame.MainFrame(): done" );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents ()//GEN-BEGIN:initComponents
    {
        rangeMonitor= new RangeMonitor();
        rangeMonitorContainer=new JPanel();
        jmbMain = new javax.swing.JMenuBar ();
        jmbFile = new javax.swing.JMenu ();
        jmiOpen = new javax.swing.JMenuItem ();
        jmiFileSeparatorA = new javax.swing.JSeparator ();
        jmiLastFile = new javax.swing.JMenuItem ();
        jmiFileSeparatorB = new javax.swing.JSeparator ();
        jmiClose = new javax.swing.JMenuItem ();
        jmbOptions = new javax.swing.JMenu ();
        jmiColorTheme = new javax.swing.JCheckBoxMenuItem ();
        jmiGridDash = new javax.swing.JCheckBoxMenuItem ();
        jmiGrid = new javax.swing.JCheckBoxMenuItem ();
        jmbHelp = new javax.swing.JMenu ();
        jmiContent = new javax.swing.JMenuItem ();
        jmsSeparator = new javax.swing.JSeparator ();
        jmiAbout = new javax.swing.JMenuItem ();
        jlblOutput = new javax.swing.JLabel ();
        jpnlDrawSettings = new javax.swing.JPanel ();
        jpnlHolding = new javax.swing.JPanel ();
        jpnlCanvas = new javax.swing.JPanel ();
        jlistScroller = new javax.swing.JScrollPane ();
        jlstPlayers = new javax.swing.JList ();

        jmbFile.setText ("File");

        jmiOpen.setText ("Open");
        jmiOpen.addActionListener (new java.awt.event.ActionListener ()
                                   {
                                       public void actionPerformed (java.awt.event.ActionEvent evt)
                                       {
                                           jmiOpenActionPerformed (evt);
                                       }
                                   }
                                  );

        jmbFile.add (jmiOpen);

        jmbFile.add (jmiFileSeparatorA);
        jmiLastFile.addActionListener (new java.awt.event.ActionListener ()
                                       {
                                           public void actionPerformed (java.awt.event.ActionEvent evt)
                                           {
                                               jmiLastFileActionPerformed (evt);
                                           }
                                       }
                                      );

        jmbFile.add (jmiLastFile);

        jmbFile.add (jmiFileSeparatorB);
        jmiClose.setText ("Close");
        jmiClose.addActionListener (new java.awt.event.ActionListener ()
                                    {
                                        public void actionPerformed (java.awt.event.ActionEvent evt)
                                        {
                                            jmiCloseActionPerformed (evt);
                                        }
                                    }
                                   );

        jmbFile.add (jmiClose);
        jmbMain.add (jmbFile);
        jmbOptions.setText ("Options");

        jmiColorTheme.setToolTipText ("");
        jmiColorTheme.setText ("Color Theme:");
        jmiColorTheme.addActionListener (new java.awt.event.ActionListener ()
                                         {
                                             public void actionPerformed (java.awt.event.ActionEvent evt)
                                             {
                                                 jmiColorThemeActionPerformed (evt);
                                             }
                                         }
                                        );

        jmbOptions.add (jmiColorTheme);
        jmiGridDash.setText ("Grid DashLine");
        jmiGridDash.addActionListener (new java.awt.event.ActionListener ()
                                       {
                                           public void actionPerformed (java.awt.event.ActionEvent evt)
                                           {
                                               jmiGridDashActionPerformed (evt);
                                           }
                                       }
                                      );

        jmbOptions.add (jmiGridDash);

        jmiGrid.setText ("Grid");
        jmiGrid.addActionListener (new java.awt.event.ActionListener ()
                                   {
                                       public void actionPerformed (java.awt.event.ActionEvent evt)
                                       {
                                           jmiGridActionPerformed (evt);
                                       }
                                   }
                                  );

        jmbOptions.add (jmiGrid);

        jmbMain.add (jmbOptions);
        jmbHelp.setText ("Help");

        jmiContent.setText ("Content");
        jmiContent.addActionListener (new java.awt.event.ActionListener ()
                                      {
                                          public void actionPerformed (java.awt.event.ActionEvent evt)
                                          {
                                              jmiHelpActionPerformed (evt);
                                          }
                                      }
                                     );

        jmbHelp.add (jmiContent);

        jmbHelp.add (jmsSeparator);
        jmiAbout.setText ("About");
        jmiAbout.addActionListener (new java.awt.event.ActionListener ()
                                    {
                                        public void actionPerformed (java.awt.event.ActionEvent evt)
                                        {
                                            jmiAboutActionPerformed (evt);
                                        }
                                    }
                                   );

        jmbHelp.add (jmiAbout);
        jmbMain.add (jmbHelp);
        setName ("frmMainWindow");
        addWindowListener (new java.awt.event.WindowAdapter ()
                           {
                               public void windowClosing (java.awt.event.WindowEvent evt)
                               {
                                   exitForm (evt);
                               }
                           }
                          );

        jlblOutput.setBorder (new javax.swing.border.EtchedBorder ());
        jlblOutput.setText ("Welcome");
        jlblOutput.setToolTipText ("I love u");


        getContentPane ().add (jlblOutput, java.awt.BorderLayout.SOUTH);

        jpnlDrawSettings.setLayout (new java.awt.GridLayout (0, 1));
        jpnlDrawSettings.setBorder (new javax.swing.border.TitledBorder ("Show: "));


        getContentPane ().add (jpnlDrawSettings, java.awt.BorderLayout.WEST);

        jpnlHolding.setLayout (new java.awt.BorderLayout ());

        jpnlCanvas.setLayout (new java.awt.BorderLayout ());

        jpnlHolding.add (jpnlCanvas, java.awt.BorderLayout.CENTER);

        getContentPane ().add (jpnlHolding, java.awt.BorderLayout.CENTER);

        jlistScroller.setBorder (new javax.swing.border.TitledBorder ("Players: "));
        jlstPlayers.setToolTipText ("Hold down ctrl + mouse click to select multiple players");
        jlstPlayers.addListSelectionListener (new javax.swing.event.ListSelectionListener ()
                                              {
                                                  public void valueChanged (javax.swing.event.ListSelectionEvent evt)
                                                  {
                                                      jlstPlayersValueChanged (evt);
                                                  }
                                              }
                                             );

        jlistScroller.setViewportView (jlstPlayers);


        getContentPane ().add (jlistScroller, java.awt.BorderLayout.EAST);

        setJMenuBar (jmbMain);

    }//GEN-END:initComponents

    private void jmiGridDashActionPerformed (java.awt.event.ActionEvent evt)
    {//GEN-FIRST:event_jmiGridDashActionPerformed
        /** Display graph of output per city */
        Debug.trace ( "MainFrame.jmiGridDashActionPerformed: ActionPerformed");

        JCheckBoxMenuItem cb = (JCheckBoxMenuItem) evt.getSource ();

        view.setDisplayDashGrid(cb.isSelected ());
    }//GEN-LAST:event_jmiGridDashActionPerformed

    private void jmiGridActionPerformed (java.awt.event.ActionEvent evt)
    {//GEN-FIRST:event_jmiGridDashActionPerformed
        JCheckBoxMenuItem cb = (JCheckBoxMenuItem) evt.getSource ();

        view.setDisplayGrid(cb.isSelected ());
    }//GEN-LAST:event_jmiGridDashActionPerformed

    private void jmiColorThemeActionPerformed (java.awt.event.ActionEvent evt)
    {//GEN-FIRST:event_jmiColorThemeActionPerformed
        /** Display graph of output per city */
        Debug.trace ( "MainFrame.jmiColorThemeActionPerformed: ActionPerformed");

        JCheckBoxMenuItem cb = (JCheckBoxMenuItem) evt.getSource ();

        if (cb.isSelected ())
        {
            // check box marked
            Debug.trace ( "MainFrame.jmiColorThemeActionPerformed: selected: ");
            cb.setSelected (true);
            CLProperties.setProperty ("colorTheme", "true");
            // Tell the color manager to use other color theme
            ColorManager.setTheme (ColorManager.THEME_WHITE);
            cb.setText ( "Color Theme: White" );
        }
        else
        {
            // check box unmarked
            Debug.trace ( "MainFrame.jmiColorThemeActionPerformed: deselected: ");
            cb.setSelected (false);
            CLProperties.setProperty ("colorTheme", "false");
            // Tell the color manager to use other color theme
            ColorManager.setTheme (ColorManager.THEME_BLACK);
            cb.setText ( "Color Theme: Black" );
        }

        graphList.repaint ();
    }//GEN-LAST:event_jmiColorThemeActionPerformed


    private void jmiLastFileActionPerformed (java.awt.event.ActionEvent evt)
    {//GEN-FIRST:event_jmiLastFileActionPerformed
        String strAction = evt.getActionCommand ();
        Debug.trace ( "MainFrame.jmiLastFile: ActionPerformed: " + strAction );

        openFile (new File(lastFile));

    }//GEN-LAST:event_jmiLastFileActionPerformed

    private void jmiHelpActionPerformed (java.awt.event.ActionEvent evt)
    {//GEN-FIRST:event_jmiHelpActionPerformed
        String strAction = evt.getActionCommand ();
        Debug.trace ( "MainFrame.jmiHelp: ActionPerformed: " + strAction );

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        screenSize.setSize (600, screenSize.height * 5/7);
        dlgTextBox dlg = new dlgTextBox (this, true, screenSize,
                                         new File(
                                             System.getProperty("user.dir")
                                             + System.getProperty("file.separator")
                                             + CivLog.HELP_TEXT_FILE
                                         )
                                        );
        SwingUtil.centerWindow( dlg );
        dlg.setModal (true);
        dlg.show ();
    }//GEN-LAST:event_jmiHelpActionPerformed

    private void jcbPerCityActionPerformed (java.awt.event.ActionEvent evt)
    {
        /** Display graph of output per city */
        Debug.trace ( "MainFrame.jcbPerCityActionPerformed: ActionPerformed");

        JCheckBox cb = (JCheckBox) evt.getSource ();

        view.setPerCity(cb.isSelected ());
    }

    private void jcbPercentalActionPerformed (java.awt.event.ActionEvent evt)
    {
        /** Display relative graph like the one in Age of the Empires */
        Debug.trace ( "MainFrame.jcbPercentalActionPerformed: ActionPerformed");

        JCheckBox cb = (JCheckBox) evt.getSource ();
        view.setPercental(cb.isSelected ());
    }

    private void jcbShowTurnsActionPerformed (java.awt.event.ActionEvent evt)
    {
        /** Display graph in turns instead of years */
        Debug.trace ( "MainFrame.jcbShowTurnsActionPerformed: ActionPerformed");
        JCheckBox cb = (JCheckBox) evt.getSource ();

        view.setDisplayLabeledInYears(!cb.isSelected());
    }

    private void jbtnResetActionPerformed (java.awt.event.ActionEvent evt)
    {//GEN-FIRST:event_jbtnResetActionPerformed
        Debug.trace ( "MainFrame.jbtnReset: KeyEvent: KeyReleased:");

        JButton cb = (JButton) evt.getSource ();

        setDataTypeSelected (false);
        view.setDataTypeSelected(false);
    }//GEN-LAST:event_jbtnResetActionPerformed


    private void jlstPlayersValueChanged (javax.swing.event.ListSelectionEvent evt)
    {//GEN-FIRST:event_jlstPlayersValueChanged
        //String strAction = evt.toString ();
        Debug.trace ( "MainFrame.jlstPlayers: ValueChanged: " );

        if (evt.getValueIsAdjusting ())
            return;

        /** multiple selection mode to be implemeted in future */
        JList list = (JList)evt.getSource ();
        for (int i = 0; i < list.getModel ().getSize (); i++)
        {
            view.setPlayerSelected (i,list.isSelectedIndex (i));
        }
    }//GEN-LAST:event_jlstPlayersValueChanged

    private void updateStatusLine()
    {
        jlblOutput.setText ( "Display: year range: "+
                             score.turn2year(view.getStartTurn())+" - "+
                             score.turn2year(view.getEndTurn())+
                             " turn range: "+
                             view.getStartTurn()+" - "+
                             view.getEndTurn());
    }

    private void jmiCloseActionPerformed (java.awt.event.ActionEvent evt)
    {//GEN-FIRST:event_jmiCloseActionPerformed
        String strAction = evt.getActionCommand ();
        Debug.trace ( "MainFrame.jmiClose: ActionPerformed: " + strAction );

        System.exit (0);
    }//GEN-LAST:event_jmiCloseActionPerformed

    private void jmiOpenActionPerformed (java.awt.event.ActionEvent evt)
    {//GEN-FIRST:event_jmiOpenActionPerformed
        String strAction = evt.getActionCommand ();
        Debug.trace ( "MainFrame.jmiOpen: ActionPerformed: " + strAction );

        /** will add a progress bar later */
        jlblOutput.setText ("Loading........  Please wait less than one minute"
                            + " while the program process the values");
        int retval = chooser.showDialog (this, null);
        File theFile;
        jlblOutput.setText ("email your comments or patches to me.");

        if (retval == JFileChooser.APPROVE_OPTION)
        {
            theFile = chooser.getSelectedFile ();
            // save selected path as Property
            try
            {
                if (theFile.isFile () && theFile.canRead ())
                {
                    //System.out.println("XXXXX AsolutePath: "+theFile.getAbsolutePath());
                    //System.out.println("XXXXX canonicalPath: "+theFile.getCanonicalPath());
                    //System.out.println("XXXXX parent: "+theFile.getParent());
                    //System.out.println("XXXXX path: "+theFile.getPath());
                    //System.out.println("XXXXX isDir: "+theFile.isDirectory());
                    //System.out.println("XXXXX isFile: "+theFile.isFile());
                    CLProperties.setProperty ("loadPath", theFile.getParent ());
                    lastFile = theFile.getAbsolutePath ();
                    jmiLastFile.setText (lastFile);
                }
            }
            catch (Exception ex)
            {
                ex.printStackTrace();
            }
            openFile (theFile);
        }

    }//GEN-LAST:event_jmiOpenActionPerformed

    private void jmiAboutActionPerformed (java.awt.event.ActionEvent evt)
    {//GEN-FIRST:event_jmiAboutActionPerformed
        String strAction = evt.getActionCommand ();
        Debug.trace ( "MainFrame.jmiAbout: ActionPerformed: " + strAction );

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        screenSize.setSize (430, 300);
        dlgTextBox dlg = new dlgTextBox (this, true, screenSize,
                                         new File(
                                             System.getProperty("user.dir")
                                             + System.getProperty("file.separator")
                                             + CivLog.ABOUT_TEXT_FILE
                                         )
                                        );
        SwingUtil.centerWindow( dlg );
        dlg.setModal (true);
        dlg.show ();
    }//GEN-LAST:event_jmiAboutActionPerformed

    public void openFile (File theFile)
    {
        Debug.trace ( "MainFrame.OpenFile: " );

        jlblOutput.setText ("Loading........  Please wait less than one minute"
                            + " while the program process the values");

        setDataTypeSelected (false);

        Score newScore = new Score (this,this);
        if (newScore.loadScoreFile (theFile.getPath ()))
        {
            score=newScore;
            view=new View (score.numofPlayers);
            graphList.init (score,view);
            rangeMonitor.init(score,view);

            view.setStartTurn (score.firstTurn);
            view.setEndTurn (score.lastTurn);

            jlstPlayers.setListData (score.playerNames);
            synchronizeWithView();

            if(jlstPlayers.getSelectedIndices().length==0)
                jlstPlayers.setSelectedIndex(0);

            graphList.repaint (); /** update the display */
            jlstPlayers.repaint ();
            jlblOutput.setText ("email your comments or "+
                                "patches to "+CivLog.EMAIL
                                +"| Drag a selection using left mouse btn, "
                                +"middle mouse btn zoom in, right mouse btn "
                                +"zoom out");
            setDataTypeEnabled (true);
        }
        else
        {
            jlblOutput.setText ("email your comments or patches to "
                                +CivLog.EMAIL);
        }
    }

    /* one Listener-class for all data-type CheckBoxes */
    private class DataCheckBoxListener implements ActionListener
    {
        int number = 0;

        public DataCheckBoxListener (int num)
        {
            number = num;
        }

        public void actionPerformed (java.awt.event.ActionEvent evt)
        {
            String strAction = evt.getActionCommand ();
            Debug.trace ( "MainFrame.DataCheckBoxListener: "+
                          "ActionPerformed for "+number+": "+ strAction );

            JCheckBox cb = (JCheckBox) evt.getSource ();
            view.setDataTypeSelected (number, cb.isSelected ());
        }
    }


    /** Initialized my Draw Panel */
    private void myInitComponents ()
    {
        Debug.trace ( "MainFrame.myInitComponents(): initializing");

        /** create misc components */
        jcbPerCity = new javax.swing.JCheckBox ();
        jbtnReset = new javax.swing.JButton ();
        jcbPerCity.setToolTipText ("Display Output as per City");
        jcbPerCity.setMnemonic ('1');
        jcbPerCity.setText ("View per City");
        jcbPerCity.addActionListener (new java.awt.event.ActionListener ()
                                      {
                                          public void actionPerformed (java.awt.event.ActionEvent evt)
                                          {
                                              jcbPerCityActionPerformed (evt);
                                          }
                                      }
                                     );

        jpnlDrawSettings.add (jcbPerCity);

        jcbPercental = new javax.swing.JCheckBox ();
        jbtnReset = new javax.swing.JButton ();
        jcbPercental.setToolTipText ("Display Relative Graph");
        jcbPercental.setMnemonic ('2');
        jcbPercental.setText ("Relative Graph");
        jcbPercental.addActionListener (new java.awt.event.ActionListener ()
                                        {
                                            public void actionPerformed (java.awt.event.ActionEvent evt)
                                            {
                                                jcbPercentalActionPerformed (evt);
                                            }
                                        }
                                       );

        jpnlDrawSettings.add (jcbPercental);

        jcbShowTurns = new javax.swing.JCheckBox ();
        jbtnReset = new javax.swing.JButton ();
        jcbShowTurns.setToolTipText ("Display Graph in turns instead of in years");
        jcbShowTurns.setMnemonic ('3');
        jcbShowTurns.setText ("View in turns");
        jcbShowTurns.addActionListener (new java.awt.event.ActionListener ()
                                        {
                                            public void actionPerformed (java.awt.event.ActionEvent evt)
                                            {
                                                jcbShowTurnsActionPerformed (evt);
                                            }
                                        }
                                       );

        jpnlDrawSettings.add (jcbShowTurns);

        jbtnReset.setText ("Reset");
        jbtnReset.setMnemonic ('r');
        jbtnReset.addActionListener (new java.awt.event.ActionListener ()
                                     {
                                         public void actionPerformed (java.awt.event.ActionEvent evt)
                                         {
                                             jbtnResetActionPerformed (evt);
                                         }
                                     }
                                    );
        jpnlDrawSettings.add (jbtnReset);

        /** create all CheckBoxes for Data */
        jcbDataList = new JCheckBox[FreecivConstants.NUMBER_OF_DATA_TYPES];
        for (int i=0; i < FreecivConstants.NUMBER_OF_DATA_TYPES; i++)
        {
            jcbDataList[i] = new JCheckBox ();
            jcbDataList[i].setToolTipText (FreecivConstants.DATA_TOOL_TIPS[i]);
            if (FreecivConstants.DATA_MNEMONICS[i] != '.')
                jcbDataList[i].setMnemonic (FreecivConstants.DATA_MNEMONICS[i]);
            jcbDataList[i].setHorizontalTextPosition (javax.swing.SwingConstants.RIGHT);
            jcbDataList[i].setText (FreecivConstants.DATA_TEXT[i]);
            jcbDataList[i].addActionListener (new DataCheckBoxListener (i));
            jpnlDrawSettings.add (jcbDataList[i]);
        }

        rangeMonitorContainer.setLayout (new java.awt.BorderLayout ());
        rangeMonitorContainer.add(rangeMonitor,java.awt.BorderLayout.CENTER);
        rangeMonitorContainer.setBorder(new javax.swing.border.EtchedBorder());
        jpnlHolding.add (rangeMonitorContainer, java.awt.BorderLayout.NORTH);

        graphList = new GraphList ();
        jpnlCanvas.add (graphList, java.awt.BorderLayout.CENTER);

        score = new Score (this,this);

        jlstPlayers.setSelectionMode (ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        jlstPlayers.setCellRenderer (new MyCellRenderer ());

        //chooser = new JFileChooser ("scorelogs");
        // start chooser in directory saved as loadPath
        if (CLProperties.getProperty ("loadPath") == null)
            chooser = new JFileChooser (".");
        else
            chooser = new JFileChooser (CLProperties.getProperty ("loadPath"));

        /////////////////////////
        // loading settings

        /** load last file opened */
        if (CLProperties.getProperty ("lastFile") == null)
        {
            lastFile = null;
            jmiLastFile.setText ("");
        }
        else
        {
            lastFile = new String (CLProperties.getProperty ("lastFile"));
            jmiLastFile.setText (lastFile);
        }

        /** load last state of colorTheme setting */
        if ( (CLProperties.getProperty ("colorTheme") == null)
                || (CLProperties.getProperty ("colorTheme")).equals ( "false" ))
        {
            // uncheck the checkbox
            ColorManager.setTheme (1);
            jmiColorTheme.setSelected (false);
            jmiColorTheme.setText ( "Color Theme: Black" );
        }
        else
        {
            // check the checkbox
            ColorManager.setTheme (0);
            jmiColorTheme.setSelected (true);
            jmiColorTheme.setText ( "Color Theme: White" );
        }// no refresh needed, I suppose?

        /////////////////////////
        // loading settings end

        /*
         * keyboard accelerators
         */
        jmiOpen.
        setAccelerator(KeyStroke.
                       getKeyStroke(java.awt.event.KeyEvent.VK_O,
                                    java.awt.event.KeyEvent.CTRL_MASK));
        jmiLastFile.
        setAccelerator(KeyStroke.
                       getKeyStroke(java.awt.event.KeyEvent.VK_L,
                                    java.awt.event.KeyEvent.CTRL_MASK));
        jmiContent.
        setAccelerator(KeyStroke.
                       getKeyStroke(java.awt.event.KeyEvent.VK_F1, 0));
        jmiClose.
        setAccelerator(KeyStroke.
                       getKeyStroke(java.awt.event.KeyEvent.VK_X,
                                    java.awt.event.KeyEvent.CTRL_MASK));
        jmiColorTheme.
        setAccelerator(KeyStroke.
                       getKeyStroke(java.awt.event.KeyEvent.VK_C,
                                    java.awt.event.KeyEvent.CTRL_MASK));
        jmiGridDash.
        setAccelerator(KeyStroke.
                       getKeyStroke(java.awt.event.KeyEvent.VK_D,
                                    java.awt.event.KeyEvent.CTRL_MASK));
        jmiGrid.
        setAccelerator(KeyStroke.
                       getKeyStroke(java.awt.event.KeyEvent.VK_G,
                                    java.awt.event.KeyEvent.CTRL_MASK));

        /** Create Filters, only *.log can be loaded */
        civLogFilter = new myFileFilter ("log", "Freeciv Score Log Files");

        /** Create Custom FileView */
        fileView = new myFileView ();

        chooser.setDialogType (JFileChooser.OPEN_DIALOG);
        // repaint();
        chooser.setFileView (fileView);
        /** comment the line below if your sdk doesn't support it yet */
        /*chooser.setAcceptAllFileFilterUsed (true);*/
        chooser.setFileSelectionMode (JFileChooser.FILES_ONLY);
        chooser.setFileFilter (civLogFilter);
        chooser.addChoosableFileFilter (civLogFilter);

        jlistScroller.setAlignmentX (LEFT_ALIGNMENT);

        setDataTypeEnabled (false);
        Debug.trace ( "MainFrame.myInitComponents(): done");
    }

    /**
     *   For disabling the component on startup
     *   @param enabled set components Enable status
     */
    private void setDataTypeEnabled (boolean enabled)
    {
        /** data checkbox */
        for (int i=0; i < FreecivConstants.NUMBER_OF_DATA_TYPES; i++)
        {
            jcbDataList[i].setEnabled (enabled);
        }

        jbtnReset.setEnabled (enabled);
        jcbPerCity.setEnabled (enabled);
        jcbPercental.setEnabled (enabled);
        jcbShowTurns.setEnabled (enabled);
    }

    private void setDataTypeSelected (boolean selected)
    {
        for (int i=0; i < FreecivConstants.NUMBER_OF_DATA_TYPES; i++)
        {
            jcbDataList[i].setSelected (selected);
        }
    }

    /** Exit the Application */
    private void exitForm (java.awt.event.WindowEvent evt)
    {//GEN-FIRST:event_exitForm
        Debug.trace ( "MainFrame.exitForm(): exiting");

        /** save window size */
        Dimension windowSize = this.getSize ();
        CLProperties.setProperty ("windowWidth", String.valueOf (windowSize.width));
        CLProperties.setProperty ("windowHeight", String.valueOf (windowSize.height));
        /** save last file open */
        if (lastFile != null)
            CLProperties.setProperty ("lastFile", lastFile);

        /** no error */
        System.exit (0);
    }//GEN-LAST:event_exitForm

    private void synchronizeWithView()
    {
        jcbPerCity.setSelected (view.isPerCity(0)); //FIXME
        jcbPercental.setSelected (view.isPercental(0));
        jcbShowTurns.setSelected (!view.isDisplayLabeledInYears());
        jmiGrid.setSelected(view.isDisplayGrid());
        jmiGridDash.setEnabled(view.isDisplayGrid());

        jlstPlayers.setSelectedIndices(view.getPlayerSelectedIndices());

        for(int i=0;i<jcbDataList.length;i++)
        {
            jcbDataList[i].setSelected(view.isDataTypeSelected(i));
        }
        graphList.synchronizeWithView();
    }

    /** Misc components */
    private javax.swing.JCheckBox jcbPerCity;
    private javax.swing.JCheckBox jcbPercental;
    private javax.swing.JCheckBox jcbShowTurns;
    private javax.swing.JButton jbtnReset;

    /** FileView */
    private myFileView fileView;

    /** File Chooser Dialog */
    private JFileChooser chooser;

    /** Files Filter */
    private myFileFilter civLogFilter;


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuBar jmbMain;
    private javax.swing.JMenu jmbFile;
    private javax.swing.JMenuItem jmiOpen;
    private javax.swing.JSeparator jmiFileSeparatorA;
    private javax.swing.JMenuItem jmiLastFile;
    private javax.swing.JSeparator jmiFileSeparatorB;
    private javax.swing.JMenuItem jmiClose;
    private javax.swing.JMenu jmbOptions;
    private javax.swing.JCheckBoxMenuItem jmiColorTheme;
    private javax.swing.JCheckBoxMenuItem jmiGridDash;
    private javax.swing.JCheckBoxMenuItem jmiGrid;
    private javax.swing.JMenu jmbHelp;
    private javax.swing.JMenuItem jmiContent;
    private javax.swing.JSeparator jmsSeparator;
    private javax.swing.JMenuItem jmiAbout;
    private javax.swing.JLabel jlblOutput;
    private javax.swing.JPanel jpnlDrawSettings;
    private javax.swing.JPanel jpnlHolding;
    private javax.swing.JPanel jpnlCanvas;
    private javax.swing.JScrollPane jlistScroller;
    private javax.swing.JList jlstPlayers;
    // End of variables declaration//GEN-END:variables
    private JPanel rangeMonitorContainer;

}
// End of MainFrame class


/** custom ListCellRenderer for lstPlayers */
class MyCellRenderer
            extends JLabel
            implements ListCellRenderer
{
    public MyCellRenderer ()
    {
        setOpaque (true);
        setFont (new Font ("Dialog", Font.PLAIN, 12));
    }

    public Component getListCellRendererComponent (
        JList list,
        Object value,
        int index,
        boolean isSelected,
        boolean cellHasFocus)
    {
        setText (value.toString ());
        setBackground (isSelected ?
                       ColorManager.getColorForPlayer (index):
                       Color.white);
        setForeground (isSelected ?
                       Color.white:
                       ColorManager.getColorForPlayer (index));
        return this;
    }
}
//End of MainFrame.java
